﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Xml;
using System.Windows.Forms;

namespace InsertSample
{
    public partial class Form1 : Form
    {
        public string authenticationToken;
        private LoginManager.MicroareaLoginManager aLoginManager = new LoginManager.MicroareaLoginManager();
        private TbServices.TbServices aTbServices = new TbServices.TbServices();
        private DateTime applicationDate = System.DateTime.Now;

        public Form1()
        {
            InitializeComponent();
        }
        
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (!string.IsNullOrEmpty(authenticationToken))
                aLoginManager.LogOff(authenticationToken);
        }

        private void btnInsert_Click(object sender, EventArgs e)
        {
            string aXMLData = "<?xml version=\"1.0\"?>" +
                                      "<maxs:Dipendenti xmlns:maxs=\"http://www.microarea.it/Schema/2004/Smart/ImpiantiNET/Core/Dipendenti/Standard/DefaultLight.xsd\" tbNamespace=\"Document.ImpiantiNet.Core.INCore.Dipendenti\" xTechProfile=\"DefaultLight\">" +
                                         "<maxs:Data>" +
                                            "<maxs:Employee master=\"true\">" +
                                               "<maxs:Employee>" + tbxEmployeeCode.Text + "</maxs:Employee>" +
                                               "<maxs:Name>" + tbxEmployeeName.Text + "</maxs:Name>" +
                                               "<maxs:Address>" + tbxAddress.Text + "</maxs:Address>" +
                                               "<maxs:City>" + tbxCity.Text + "</maxs:City>" +
                                               "<maxs:ZipCode>" + tbxZipCode.Text + "</maxs:ZipCode>" +
                                               "<maxs:Telephone1>" + tbxTelephone.Text + "</maxs:Telephone1>" +
                                            "</maxs:Employee>" +
                                         "</maxs:Data>" +
                                      "</maxs:Dipendenti>";
            string aResult = string.Empty;

            try
            {

              // string schema = aTbServices.GetDocumentSchema(authenticationToken, "Document.ImpiantiNet.Core.INCore.Dipendenti", "DefaultLight", "Standard");
             
               if (aTbServices.SetData(authenticationToken, aXMLData, applicationDate, 1, false, out aResult))
                {
                    XmlDocument doc = new XmlDocument();
                    doc.LoadXml(aResult);
                    XmlNamespaceManager xmlNsManager = new XmlNamespaceManager(doc.NameTable);
                    xmlNsManager.AddNamespace(doc.DocumentElement.Prefix, doc.DocumentElement.NamespaceURI);
                    XmlNode emplNode = doc.SelectSingleNode("//maxs:Dipendenti//maxs:Data//maxs:Employee//maxs:Employee", xmlNsManager);
                    string employee = emplNode.InnerText;

                    MessageBox.Show(string.Format("Insert Employee!\n {0}", employee));
                    tbxEmployeeCode.Clear();
                    tbxEmployeeName.Clear();
                    tbxAddress.Clear();
                    tbxCity.Clear();
                    tbxZipCode.Clear();
                    tbxTelephone.Clear();
                }
                else
                {
                    XmlDocument doc = new XmlDocument();
                    doc.LoadXml(aResult);
                    XmlNamespaceManager xmlNsManager = new XmlNamespaceManager(doc.NameTable);
                    xmlNsManager.AddNamespace(doc.DocumentElement.Prefix, doc.DocumentElement.NamespaceURI);
                    XmlNodeList errors = doc.SelectNodes("//maxs:Dipendenti//maxs:Diagnostic//maxs:Errors//maxs:Error", xmlNsManager);
                    string strMessage = string.Empty;
                    foreach (XmlNode node in errors)
                    {
                        strMessage += node.SelectSingleNode("maxs:Message", xmlNsManager).InnerText;
                    }
                    MessageBox.Show(string.Format("Not posted, some error occurred!\n {0}", strMessage));                    
                }                
            }
            catch (Exception tbExc)
            {
                MessageBox.Show(string.Format("Exception occurred: {0}", tbExc.Message));
            }
        }
    
        private void btnLogin_Click(object sender, EventArgs e)
        {            
            string authToken = string.Empty;
            string user     = textUser.Text;
            string company  = textCompany.Text;
            string password = textPassword.Text;
            string prodKey  = textProdKey.Text;

            try
            {
                int aResult = aLoginManager.LoginCompact(ref user, ref company, password, prodKey, false, out authToken);

                if (aResult == 0)
                {
                    authenticationToken = authToken;

                    textUser.Enabled = false;
                    textPassword.Enabled = false;
                    textCompany.Enabled = false;
                    textProdKey.Enabled = false;
                    btnLogin.Enabled = false;

                    tbxEmployeeCode.Enabled = true;
                    tbxEmployeeName.Enabled = true;
                    tbxAddress.Enabled = true;
                    tbxCity.Enabled = true;
                    tbxZipCode.Enabled = true;
                    tbxTelephone.Enabled = true;
                    btnInsert.Enabled = true;
                }
                else
                    MessageBox.Show(string.Format("Error occurred, code: {0}", aResult));
            }
            catch (Exception logExc)
            {
                MessageBox.Show(string.Format("Exception occurred: {0}", logExc.Message));
            }
        }
     
    }
}
/*
 <?xml version="1.0"?>
<maxs:Dipendenti xmlns:maxs="http://www.microarea.it/Schema/2004/Smart/ImpiantiNET/Core/Dipendenti/Standard/DefaultLight.xsd" tbNamespace="Document.ImpiantiNet.Core.INCore.Dipendenti" xTechProfile="DefaultLight">
    <maxs:Data>
        <maxs:Employee master="true">
            <maxs:Employee>aaaaaaa</maxs:Employee>
            <maxs:Name>ssssssssssss</maxs:Name>
            <maxs:Address>dddddddddddd</maxs:Address>
            <maxs:City>aaaa</maxs:City>
            <maxs:ZipCode>60025</maxs:ZipCode>
            <maxs:Telephone1>07100001</maxs:Telephone1>
        </maxs:Employee>
    </maxs:Data>
    <maxs:Diagnostic>
        <maxs:Errors>
            <maxs:Error>
                <maxs:Code>-3</maxs:Code>
                <maxs:Source>TbServices</maxs:Source>
                <maxs:Message>Errore istanziando il TBLoader sul server. EasyLookConnectionCodes: -1</maxs:Message>
            </maxs:Error>
        </maxs:Errors>
    </maxs:Diagnostic>
</maxs:Dipendenti>
*/